'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *  Utility methods that may come in handy in projects
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */


var _nodeUuid = require('node-uuid');

var _nodeUuid2 = _interopRequireDefault(_nodeUuid);

var _api = require('./api');

var _api2 = _interopRequireDefault(_api);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Utils = function () {
  function Utils() {
    _classCallCheck(this, Utils);
  }

  _createClass(Utils, null, [{
    key: 'convertParamToObject',
    value: function convertParamToObject(param) {
      if (param && typeof param === 'string') {
        try {
          param = JSON.parse(param);
        } catch (e) {
          return {};
        }
      } else if (!param) {
        return {};
      }

      return param;
    }

    /**
      * Generate a pretty unique prefix
      *
      */

  }, {
    key: 'generatePrefix',
    value: function generatePrefix() {
      return Math.floor(Math.random() * 1000000000).toString(36);
    }

    /**
      *  Generate a unique key that can be used for authorization, password reset, etc
      */

  }, {
    key: 'generateKey',
    value: function generateKey() {
      var salt = new Date().getTime();
      return require('crypto').createHash('sha256').update((0, _nodeUuid2.default)()).update(salt.toString()).digest('hex');
    }

    /**
     *  handleAfterConditions is an API method used to create adjustments to this result or other model documents after the call has been made.
     *
     */

  }, {
    key: 'handleAfterConditions',
    value: function handleAfterConditions(result, conditions, req) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        if (!conditions || !result) {
          return resolve(result);
        }

        if (conditions instanceof Function) {
          return conditions(req, result).then(function (result) {
            return resolve(result);
          });
        }

        for (var action in conditions) {
          var condition = conditions[action];
          var model = void 0;
          if (!condition.request) {
            model = result;
          } else if (condition.request) {
            model = req[condition.request];
          }

          switch (action) {
            case '$push':
              if (!(model[condition.field] instanceof Array)) {
                model[condition.field] = [];
              }
              model[condition.field].push(result[condition.value]);
              break;
            case '$set':
              model[condition.field] = result[condition.value];
              break;
            case '$delete':
              delete model[condition.field];
              break;
          }

          if (condition.save) {
            model.save();
          }
        }

        return resolve(result);
      });
    }

    /**
     *  handleBeforeConditions is an API method used to inject conditions for your API that override any request. This can be useful for querying objects that are only 'active' or similar situations.
     *
     */

  }, {
    key: 'beforeConditions',
    value: function beforeConditions(req, res, next) {
      if (!req.route.config || !req.route.config.beforeConditions) {
        return next();
      }

      if (req.route.config.beforeConditions instanceof Function) {
        return req.route.config.beforeConditions(req).then(function () {
          return next();
        }).catch(function (err) {
          return _api2.default.handleError(res, { code: err.code || 500, message: err.message || 'No error message' });
        });
      }

      for (var action in req.route.config.beforeConditions) {
        var condition = req.route.config.beforeConditions[action];
        switch (action) {
          case '$add':
            req.params.conditions = Utils.convertParamToObject(req.params.conditions);
            for (var key in condition) {
              req.params.conditions[key] = condition[key];
            }
            break;
          case '$remove':
            req.params.conditions = Utils.convertParamToObject(req.params.conditions);
            for (var _key in condition) {
              delete req.params.conditions[_key];
            }
            break;
        }
      }

      return next();
    }
  }]);

  return Utils;
}();

exports.default = Utils;